﻿namespace NullableReferenceTypes {

	class A {
		public int x;
	}

	class Program {
		static void Main(string[] args) {

			A a1 = new A { x = 10 };
			Console.WriteLine($"a1 == {a1}");

			// Warning: Converting null literal or possible null value to non - nullable type.
			a1 = null;
			Console.WriteLine($"a1 == {a1}");

			A? a2 = new A { x = 10 };
			Console.WriteLine($"a2 == {a2}");

			a2 = null;
			Console.WriteLine($"a2 == {a2}");

			//

			// a2 = new A();

			// Warning: Dereference of a possibly null reference.
			Console.WriteLine(a2.x);

			// a1 = new A();

			// Warning: Dereference of a possibly null reference.
			Console.WriteLine(a1.x);

			//

			var p1 = new Person("Jan", "Kofron");
			Console.WriteLine(p1);
			var p2 = new Person("Pavel", "Jezek") { MiddleName = "Sonic" };
			Console.WriteLine(p2);
		}
	}

	record Person {
		public string FirstName { get; init; }
		public string? MiddleName { get; init; }
		public string LastName { get; init; }

		public Person(string firstName, string lastName) {
			FirstName = firstName;
			LastName = lastName;
		}
	}

}