﻿interface IPackage { }

record class WeightlessStringPackage(string Payload) : IPackage { }

interface IMailDuck {
	public void LoadPackage(IPackage package);
	public void SignalArrival();
	public string Name { get; }
}

record class MailDuck(string Name) : IMailDuck {
	public void LoadPackage(IPackage package) {
		Console.WriteLine($"C#: Duck {Name} acccepted package {package}.");
	}

	public void SignalArrival() {
		Console.WriteLine($"C#: Duck {Name} generating sound: QUAAACK");
	}
}

record class MailSwan(string Name) : IMailDuck {
	public void LoadPackage(IPackage package) {
		Console.WriteLine($"C#: Swan {Name} acccepted package {package}.");
	}

	public void SignalArrival() {
		Console.WriteLine($"C#: Swan {Name} generating sound: TSSSSS");
	}
}

class Program {
	static void Main(string[] args) {
		var duck = new MailDuck("Teri");
		duck.SignalArrival();
		var swan = new MailSwan("Bety");
		swan.SignalArrival();

		Console.WriteLine();
		var oneWordPackage = new WeightlessStringPackage("pillow");

		PostPackage(oneWordPackage, duck);
		PostPackage(oneWordPackage, swan);

		var ship = new WolfGoatCabbageShip();
		// Error: Argument 2: cannot convert from 'WolfGoatCabbageShip' to 'IMailDuck'
		// PostPackage(oneWordPackage, ship);
	}

	static void PostPackage(IPackage package, IMailDuck carrier) {
		Console.WriteLine("C# >>> Posting a package >>>");
		Console.WriteLine("+ Stage 1 - package loading:");
		if (package is WeightlessStringPackage weightless) {
			Console.WriteLine($"C#: whispering '{weightless.Payload}' to {carrier.Name} ...");
		} else {
			carrier.LoadPackage(package);
		}
		Console.WriteLine("+ Last stage - arrival:");
		carrier.SignalArrival();
		Console.WriteLine();
	}
}

record class WolfGoatCabbageShip;